/*-------------------------

  PlayStation Net-yarouze

  RACE2 main1.c

  1997 Kame

-------------------------*/

/* include */

#include <libps.h>
#include <stdio.h>
#include <rand.h>
#include "pad.h"
#include "sin.h"
#include "sound.h"

/* define */

#define DEBUG 0

#define PACKET_MAX 0x20000
#define OBJECT_MAX 0x200
#define SPRITE_MAX 0x100
#define OT_LENGTH 10
#define OT_TAGS 1024
#define SIZE 256
#define PROJE 400

#define MODEL1_ADDR 0x80090000
#define MODEL2_ADDR 0x80091000
#define MODEL3_ADDR 0x80092000
#define MODEL4_ADDR 0x80093000
#define TIM1_ADDR 0x80094000
#define TIM2_ADDR 0x80095000
#define SEQ1_ADDR 0x80096000
#define SEQ2_ADDR 0x80097000
#define SEQ3_ADDR 0x80098000

#define VIEW_DIST 256
#define UFO_DIST 96

#define STAR_MAX 64

/* struct */

struct MAP_STRUCT {

  int sx;
  int sz;
  int gx;
  int gz;
  char data[256];

};

struct MAP_STRUCT map_data={
  16,16,
  17,16,
  "77777777111111113333333355553333555577770"
};

/* global */

GsOT mot[2];
GsOT_TAG mot_tag[2][OT_TAGS]; 
GsDOBJ2	obje[OBJECT_MAX];
GsCOORDINATE2 mworld[32][32];
GsCOORDINATE2 uworld;
GsCOORDINATE2 sworld[STAR_MAX];
GsRVIEW2 rview;
GsSPRITE tspr[SPRITE_MAX];
PACKET packet_area[2][PACKET_MAX];

volatile u_char *pad1,*pad2;
int pad;

int obje_num;
int tspr_num;

int mode; /* mode */

int rtime;

int ux,uz,dir,spd,chf; /* ufo data */

int vh; /* view height */

static char map[32][32];

/* main */

main(){

  GsDOBJ2 *op;
  MATRIX  lws;
  GsSPRITE *sp;
  int side; /* active buf */
  int flag; /* main loop flag */
  int i;

  init_sub();

  flag=0;
  while(flag==0){

    flag=main_sub();

    side=GsGetActiveBuff();

    GsSetWorkBase((PACKET *)packet_area[side]);

    GsClearOt(0,0,&mot[side]);

    op=obje;
    for(i=0;i<obje_num;i++){
/*
      GsGetLw(op->coord2,&lws);
      GsSetLightMatrix(&lws);
*/	  
      GsGetLs(op->coord2,&lws);
      GsSetLsMatrix(&lws);
	  
      GsSortObject4(op,&mot[side],14-OT_LENGTH,(u_long *)0x1f800000);
      op++;

    }

    sp=tspr;
    for(i=0;i<tspr_num;i++){

      GsSortSprite(sp,&mot[side],0);
      sp++;

    }

    VSync(0);
    DrawSync(0);

    GsSwapDispBuff();

    GsSortClear(0,0,0,&mot[side]);
      
    GsDrawOt(&mot[side]);

  }

  VSync(0);

  stop_sound_sub();
  close_seq_sub();
  exit_sound_sub();

  VSync(0);

}

/* init_sub */

init_sub(){

  int i;

  if(DEBUG) printf("init_sub\n");

  GetPadBuf(&pad1, &pad2);
  pad=65535;

  GsInitGraph(320,240,4,0,0);
  GsDefDispBuff(0,0,0,240);

  GsInit3D();

  for(i=0;i<2;i++){

    mot[i].length=OT_LENGTH;
    mot[i].org=mot_tag[i];

  }

  init_tmd_sub();

  init_tim_sub();

  init_world_sub();

  init_sound_sub();

  mode=0;

}

/* init_tmd_sub */

init_tmd_sub(){

  if(DEBUG) printf("init_tmd_sub\n");

  load_tmd_sub(MODEL1_ADDR);
  load_tmd_sub(MODEL2_ADDR);
  load_tmd_sub(MODEL3_ADDR);
  load_tmd_sub(MODEL4_ADDR);

}

/* load_tmd_sub */

load_tmd_sub(u_long addr){

  if(DEBUG) printf("load_tmd_sub\n");

  GsMapModelingData((u_long *)(addr+4));

}

/* init_tim_sub */

init_tim_sub(){

  if(DEBUG) printf("init_tim_sub\n");

  load_tim_sub(320,0,320,480,TIM1_ADDR);
  load_tim_sub(384,0,320,481,TIM2_ADDR);

}

/* load_tim_sub */

load_tim_sub(int px,int py,int cx,int cy,u_long addr){

  RECT rect;
  GsIMAGE image;

  GsGetTimInfo((u_long *)(addr+4),&image);

  rect.x=px; 
  rect.y=py;
  rect.w=image.pw;
  rect.h=image.ph;
  LoadImage(&rect,image.pixel);
  DrawSync(0);

  rect.x=cx; 
  rect.y=cy;
  rect.w=image.cw;
  rect.h=image.ch;
  LoadImage(&rect,image.clut);
  DrawSync(0);

}

/* init_world_sub */

init_world_sub(){

  int i;
  int x,z;

  if(DEBUG) printf("init_world_sub\n");

  for(z=0;z<32;z++){
    for(x=0;x<32;x++){

      GsInitCoordinate2(WORLD,&mworld[x][z]);

      mworld[x][z].coord.t[0]=x*SIZE+(SIZE/2);
      mworld[x][z].coord.t[1]=SIZE;
      mworld[x][z].coord.t[2]=z*SIZE+(SIZE/2);

    }
  }

  for(i=0;i<STAR_MAX;i++){

    GsInitCoordinate2(WORLD,&sworld[i]);

    sworld[i].coord.t[0]=rand()%(32*SIZE);
    sworld[i].coord.t[1]=rand()%(3*SIZE);
    sworld[i].coord.t[2]=rand()%(32*SIZE);

  }

}

/* main_sub */

int main_sub(){

  if(DEBUG) printf("main_sub\n");

  pad=(*(pad1+2))*256+(*(pad1+3));

  if((pad & PAD_ST)==0) return 1;

  if(mode==0) data_sub();
  if(mode==1) start_sub();
  if(mode==2) race_sub();
  if(mode==3) goal_sub();

  return 0;

}

/* data_sub */

data_sub(){

  int i;
  int x,z;
  int m;

  if(DEBUG) printf("data_sub\n");

  for(z=0;z<32;z++){
    for(x=0;x<32;x++){
      map[x][z]=0;
    }
  }

  x=map_data.sx; z=map_data.sz;

  for(i=0;i<256;i++){
    m=map_data.data[i]-48;
    if(m==0) i=256;
    else{
      map[x][z]=m;
      if(m==1) z--;
      if(m==3) x++;
      if(m==5) z++;
      if(m==7) x--;
    }
  }

  map[map_data.sx][map_data.sz]+=10;
  map[map_data.gx][map_data.gz]+=20;

  obje_num=0;

  for(i=0;i<STAR_MAX;i++){

    set_obje_sub(&sworld[i],MODEL4_ADDR);

  }

  for(z=0;z<32;z++){
    for(x=0;x<32;x++){
      if(map[x][z]>0 && map[x][z]<10) set_obje_sub(&mworld[x][z],MODEL2_ADDR);
      if(map[x][z]>10) set_obje_sub(&mworld[x][z],MODEL3_ADDR);
    }
  }

  ux=map_data.sx; uz=map_data.sz;
  dir=dir_sub(map[ux][uz]%10);
  ux=ux*SIZE+(SIZE/2); uz=uz*SIZE+(SIZE/2);
  spd=0; chf=0;

  GsInitCoordinate2(WORLD,&uworld);

  uworld.coord.t[0]=ux;
  uworld.coord.t[1]=UFO_DIST;
  uworld.coord.t[2]=uz;

  set_obje_sub(&uworld,MODEL1_ADDR);

  rtime=0;

  vh=UFO_DIST/2;

  open_seq_sub(SEQ1_ADDR);
  play_sound_sub(1);
  mode=1;

}

/* start_sub */

start_sub(){

  if(DEBUG) printf("start_sub\n");

  draw_sub();

  if(check_sound_sub()==0){
    stop_sound_sub();
    close_seq_sub();
    open_seq_sub(SEQ2_ADDR);
    play_sound_sub(0);
    mode=2;
  }

}

/* race_sub */

race_sub(){

  int ax,az,mx,mz;

  if(DEBUG) printf("race_sub\n");

  if((pad & PAD_LL)==0) dir=(dir+355)%360;
  if((pad & PAD_LR)==0) dir=(dir+365)%360;

  if((pad & PAD_RD)==0 && spd>1) spd-=2;

  ax=(int)(cos_sub(dir)*100)*spd/100;
  az=(int)(sin_sub(dir)*100)*spd/100;

  ux+=ax; uz+=az;
  mx=ux/SIZE; mz=uz/SIZE;

  if(map[mx][mz]==0){
    ux-=ax*2; uz-=az*2;
    spd=0;
  }
  if(map[mx][mz]>20 && chf==0){
    ux-=ax*2; uz-=az*2;
    spd=0;
  }
  if(map[mx][mz]>20 && chf==1){
    stop_sound_sub();
    close_seq_sub();
    open_seq_sub(SEQ3_ADDR);
    play_sound_sub(0);
    mode=3;
  }
  if(map[mx][mz]>10 && map[mx][mz]<20){
    chf=0;
  }
  if(map[mx][mz]>0 && map[mx][mz]<10){
    chf=1;
  }

  if(spd<20) spd++;

  rtime++;

  draw_sub();

}

/* goal_sub */

goal_sub(){

  int ax,az,ad;

  if(DEBUG) printf("goal_sub\n");

  ad=dir_sub(map[(ux/SIZE)][(uz/SIZE)]%10);
  if(dir<ad){
    if((ad-dir)<180) dir=(dir+365)%360;
    else dir=(dir+355)%360;
  }
  if(dir>ad){
    if((dir-ad)<180) dir=(dir+355)%360;
    else dir=(dir+365)%360;
  }
  spd=10;

  ax=(int)(cos_sub(dir)*100)*spd/100;
  az=(int)(sin_sub(dir)*100)*spd/100;

  ux+=ax; uz+=az;

  draw_sub();

  if((pad & PAD_RR)==0){
    stop_sound_sub();
    close_seq_sub();
    mode=0;
  }

}

/* draw_sub */

draw_sub(){

  if(DEBUG) printf("draw_sub\n");

  obje_num--;

  GsInitCoordinate2(WORLD,&uworld);

  uworld.coord.t[0]=ux;
  uworld.coord.t[1]=UFO_DIST;
  uworld.coord.t[2]=uz;

  set_obje_sub(&uworld,MODEL1_ADDR);

  if((pad & PAD_L1)==0 || (pad & PAD_R1)==0) vh+=5;
  if((pad & PAD_L2)==0 || (pad & PAD_R2)==0) vh-=5;

  rview.vrx=ux;
  rview.vry=UFO_DIST;
  rview.vrz=uz;

  rview.vpx=rview.vrx-(cos_sub(dir)*VIEW_DIST);
  rview.vpy=vh;
  rview.vpz=rview.vrz-(sin_sub(dir)*VIEW_DIST);

  GsSetRefView2(&rview);
  GsSetProjection(PROJE);

  tspr_num=0;

  set_spr_sub(&tspr[tspr_num], 96, 16,64,8,320, 0,320,480);
  tspr_num++;
  set_spr_sub(&tspr[tspr_num],192,192,64,8,320,24,320,480);
  tspr_num++;
  time_sub();
  if(mode==1){
    set_spr_sub(&tspr[tspr_num],112,112,64,8,320, 8,320,480);
    tspr_num++;
  }
  if(mode==3){
    set_spr_sub(&tspr[tspr_num],120,112,64,8,320,16,320,480);
    tspr_num++;
  }
}

/* time_sub */

time_sub(){

  int i;
  char str[6];

  if(DEBUG) printf("time_sub\n");

  sprintf(str,"%06d",rtime);

  for(i=0;i<6;i++){
    set_spr_sub(&tspr[tspr_num],192+i*16,208,8,8,384,(str[i]-48)*8,320,481);
    tspr_num++;
  }

}

/* dir_sub */

int dir_sub(int n){

  if(DEBUG) printf("dir_sub\n");

  if(n==1) return  90;
  if(n==3) return   0;
  if(n==5) return 270;
  if(n==7) return 180;

}

/* set_obje_sub */

set_obje_sub(GsCOORDINATE2 *coord,u_long addr){

  if(DEBUG) printf("set_obje_sub\n");

  GsLinkObject4((u_long)(addr+12),&obje[obje_num],0);

  obje[obje_num].coord2=coord;
  obje[obje_num].attribute=64;

  obje_num++;

  if(DEBUG) printf("obje_num %d\n",obje_num);

}

/* set_spr_sub */

set_spr_sub(GsSPRITE *sp,int x,int y,int w,int h,int px,int py,int cx,int cy){

  if(DEBUG) printf("set_spr_sub\n");

  x-=160; y-=120;

  sp->attribute=0;
  sp->x=x; sp->y=y;
  sp->w=w; sp->h=h;
  sp->tpage=GetTPage(0,0,px,0);
  sp->u=0; sp->v=py;
  sp->cx=cx; sp->cy=cy;
  sp->r=sp->g=sp->b=0x80;
  sp->mx=0; sp->my=0;
  sp->scalex=4096*2; sp->scaley=4096*2;
  sp->rotate=0;

}

/* end of file */
